.586
.mmx
.xmm

.model flat,stdcall
option casemap:none

   include windows.inc
   include user32.inc
   include kernel32.inc
   include gdi32.inc
   include DB_example.inc
   
   includelib masm32.lib
   includelib gdi32.lib
   includelib user32.lib
   includelib kernel32.lib
   
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
onTimer proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

.data
   ClassName db "DBE",0
   AppName  db "Double buffer example.",0
   
   text db "I am a simple application demonstrate double buffer.",0
	
.data?
	hDC dd ?
	Layer1 dd ?
	Layer1Bmp dd ?
	
	CommandLine dd ?
	hInstance dd ?
	hwnd dd ?
	
	text_pos POINT <?>
	
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX 
	LOCAL msg:MSG 
	
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW\
           ,0,\
           0,800,600,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc uses esi edi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
		
	.elseif uMsg==WM_CREATE
		invoke GetDC,hWnd
		mov hDC,eax
		; Create a layer for drawing.
		invoke CreateLayer,hDC,800,600
		mov Layer1,edx
		
		mov text_pos.x,10
		mov text_pos.y,10
		invoke SetTimer,hWnd,1,1000/20,addr onTimer
	.elseif uMsg==WM_KEYUP
		invoke PostQuitMessage,NULL
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	
	xor eax,eax
	ret
WndProc endp

onTimer proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	
	invoke GetStockObject,BLACK_BRUSH
	invoke SelectObject,Layer1,eax
	invoke Rectangle,Layer1,0,0,800,600
	
	invoke SetBkMode,Layer1,TRANSPARENT
	invoke SetTextColor,Layer1,0ffh
	
	sub text_pos.x,3
	jns @f
		mov text_pos.x,800
	@@:
	
	invoke TextOut,Layer1,text_pos.x,text_pos.y,addr text, sizeof text-1
	invoke BitBlt,hDC,0,0,800,600,Layer1,0,0,SRCCOPY
	
	ret
onTimer endp


end start